#ifndef __VRML_h
#define __VRML_h

#include <stdio.h>
#include <math.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedFaceSet.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoTexture2Transform.h>
#include <Inventor/actions/SoWriteAction.h>

#include "Global.h"
#include "DEM.h"
#include "MeshSimp.h"
#include "SoTerrain.h"
//#include "GeoPrim.h"

class OutFile {
public:
  FILE *f; //unfortunately public -- for triangle
  SoSeparator *root;
  SoCoordinate3 *coor;
  SoIndexedFaceSet *face;
  int nodeCounter, faceCounter;

  OutFile();
  ~OutFile();

  virtual void writeHeader() = 0;

  void writeInitialParams();
  void writeTextureData(class DEM *df);

  void startListOfNodes();
  void writeNode(COOR x, COOR y, ELEV z);
  void finishListOfNodes();

  void startListOfFaces();
  void writeFace(int a, int b, int c);
  void finishListOfFaces();
  void finishFile();

  void dumpToFile(char *fname);
};

class VRMLFile : public OutFile {
public:
  VRMLFile() : OutFile() {} ;
  virtual void writeHeader() ;
};

class IVFile : public OutFile {
public:
  IVFile() : OutFile() {} ;
  virtual void writeHeader() ;
};


SoSeparator * getURLTerrain(char* elevationFileName, float meshThresh);

#endif
